/*******************************************************************************
* File Name: Tx8_SCBCLK.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_Tx8_SCBCLK_H)
#define CY_CLOCK_Tx8_SCBCLK_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void Tx8_SCBCLK_StartEx(uint32 alignClkDiv);
#define Tx8_SCBCLK_Start() \
    Tx8_SCBCLK_StartEx(Tx8_SCBCLK__PA_DIV_ID)

#else

void Tx8_SCBCLK_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void Tx8_SCBCLK_Stop(void);

void Tx8_SCBCLK_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 Tx8_SCBCLK_GetDividerRegister(void);
uint8  Tx8_SCBCLK_GetFractionalDividerRegister(void);

#define Tx8_SCBCLK_Enable()                         Tx8_SCBCLK_Start()
#define Tx8_SCBCLK_Disable()                        Tx8_SCBCLK_Stop()
#define Tx8_SCBCLK_SetDividerRegister(clkDivider, reset)  \
    Tx8_SCBCLK_SetFractionalDividerRegister((clkDivider), 0u)
#define Tx8_SCBCLK_SetDivider(clkDivider)           Tx8_SCBCLK_SetDividerRegister((clkDivider), 1u)
#define Tx8_SCBCLK_SetDividerValue(clkDivider)      Tx8_SCBCLK_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define Tx8_SCBCLK_DIV_ID     Tx8_SCBCLK__DIV_ID

#define Tx8_SCBCLK_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define Tx8_SCBCLK_CTRL_REG   (*(reg32 *)Tx8_SCBCLK__CTRL_REGISTER)
#define Tx8_SCBCLK_DIV_REG    (*(reg32 *)Tx8_SCBCLK__DIV_REGISTER)

#define Tx8_SCBCLK_CMD_DIV_SHIFT          (0u)
#define Tx8_SCBCLK_CMD_PA_DIV_SHIFT       (8u)
#define Tx8_SCBCLK_CMD_DISABLE_SHIFT      (30u)
#define Tx8_SCBCLK_CMD_ENABLE_SHIFT       (31u)

#define Tx8_SCBCLK_CMD_DISABLE_MASK       ((uint32)((uint32)1u << Tx8_SCBCLK_CMD_DISABLE_SHIFT))
#define Tx8_SCBCLK_CMD_ENABLE_MASK        ((uint32)((uint32)1u << Tx8_SCBCLK_CMD_ENABLE_SHIFT))

#define Tx8_SCBCLK_DIV_FRAC_MASK  (0x000000F8u)
#define Tx8_SCBCLK_DIV_FRAC_SHIFT (3u)
#define Tx8_SCBCLK_DIV_INT_MASK   (0xFFFFFF00u)
#define Tx8_SCBCLK_DIV_INT_SHIFT  (8u)

#else 

#define Tx8_SCBCLK_DIV_REG        (*(reg32 *)Tx8_SCBCLK__REGISTER)
#define Tx8_SCBCLK_ENABLE_REG     Tx8_SCBCLK_DIV_REG
#define Tx8_SCBCLK_DIV_FRAC_MASK  Tx8_SCBCLK__FRAC_MASK
#define Tx8_SCBCLK_DIV_FRAC_SHIFT (16u)
#define Tx8_SCBCLK_DIV_INT_MASK   Tx8_SCBCLK__DIVIDER_MASK
#define Tx8_SCBCLK_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_Tx8_SCBCLK_H) */

/* [] END OF FILE */
