#include "project.h"

uint8 header[] = {0x0Du, 0x0Au};
uint8 tail[] = {0x00u, 0xFFu, 0xFFu};

int main() {
  __enable_irq(); /* Enable global interrupts. */

  Tx8_Start(); /* Start UART SCB Component */

  CapSense_Start(); /* Initialize Component */
  CapSense_ScanAllWidgets(); /* Scan all widgets */

  for (;;) { /* Do this only when a scan is done */
    if (CapSense_NOT_BUSY == CapSense_IsBusy()) {
      CapSense_ProcessAllWidgets(); /* Process all widgets */

      /* Send packet header */
      Tx8_SpiUartPutArray((uint8 * )( & header), sizeof(header)); /* Send packet with CapSense data */
      Tx8_SpiUartPutArray((uint8 * )( & CapSense_dsRam), sizeof(CapSense_dsRam)); /* Send packet tail */
      Tx8_SpiUartPutArray((uint8 * )( & tail), sizeof(tail));

      if (CapSense_IsAnyWidgetActive()) /* Scan result verification */ { /* add custom tasks to execute when touch detected */ }
      CapSense_ScanAllWidgets(); /* Start next scan */
    }
  }
}